<?php

namespace App\Entity;


use Doctrine\ORM\Mapping as ORM;

/**
 * Class PracovniPozice
 * @package App\Entity
 * @ORM\Entity()
 * @ORM\Table(name="pracovni_pozice")
 */
class PracovniPozice
{

	/**
	 * @var integer
	 * @ORM\Column(type="integer")
	 * @ORM\Id()
	 * @ORM\GeneratedValue()
	 */
	protected $id;

	/**
	 * @var string
	 * @ORM\Column(type="string")
	 */
	protected $nazevFunkce;

	/**
	 * @var Pracoviste
	 * @ORM\ManyToOne(targetEntity="Pracoviste", inversedBy="pracovniPozicePracoviste")
	 */
	protected $kteraPracoviste;

	/**
	 * @var integer
	 * @ORM\Column(type="integer")
	 */
	protected $hodinovaMzda;

	/**
	 * @var Proces
	 * @ORM\OneToMany(targetEntity="Pracovnik", mappedBy="pracovniPozice")
	 */
	protected $pridelenaPracovnikum;

	/**
	 * @return int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * @return string
	 */
	public function getNazevFunkce()
	{
		return $this->nazevFunkce;
	}

	/**
	 * @param string $nazevFunkce
	 */
	public function setNazevFunkce($nazevFunkce)
	{
		$this->nazevFunkce = $nazevFunkce;
	}

	/**
	 * @return Pracoviste
	 */
	public function getKteraPracoviste()
	{
		return $this->kteraPracoviste;
	}

	/**
	 * @return int
	 */
	public function getHodinovaMzda()
	{
		return $this->hodinovaMzda;
	}

	/**
	 * @param int $hodinovaMzda
	 */
	public function setHodinovaMzda($hodinovaMzda)
	{
		$this->hodinovaMzda = $hodinovaMzda;
	}

	/**
	 * @return Proces
	 */
	public function getPridelenaPracovnikum()
	{
		return $this->pridelenaPracovnikum;
	}

}