<?php

namespace App\Entity;


use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use Nette\Utils\DateTime;

/**
 * Class Pracovnik
 * @package App\Entity
 * @ORM\Entity()
 * @ORM\Table(name="pracovnik")
 */
class Pracovnik
{

	/**
	 * @var int
	 * @ORM\Id()
	 * @ORM\Column(type="integer")
	 * @ORM\GeneratedValue()
	 */
	protected $id;

	/**
	 * @var string
	 * @ORM\Column(type="string")
	 */
	protected $jmeno;


	/**
	 * @var string
	 * @ORM\Column(type="string")
	 *
	 */
	protected $prijmeni;


	/**
	 * @var PracovniPozice
	 * @ORM\ManyToOne(targetEntity="PracovniPozice", inversedBy="pridelenaPracovnikum")
	 *
	 */
	protected $pracovniPozice;

	/**
	 * @var ArrayCollection
	 * @ORM\ManyToMany(targetEntity="Proces", inversedBy="prirazeniPracovnici")
	 */
	protected $pridruzeneProcesy;

	/**
	 * @var DateTime
	 * @ORM\Column(type="date")
	 */
	protected $datumNastupu;

	public function __construct()
	{
		$this->pridruzeneProcesy = new ArrayCollection();
	}


	/**
	 * @return int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * @return string
	 */
	public function getJmeno()
	{
		return $this->jmeno;
	}

	/**
	 * @param string $jmeno
	 */
	public function setJmeno($jmeno)
	{
		$this->jmeno = $jmeno;
	}

	/**
	 * @return string
	 */
	public function getPrijmeni()
	{
		return $this->prijmeni;
	}

	/**
	 * @param string $prijmeni
	 */
	public function setPrijmeni($prijmeni)
	{
		$this->prijmeni = $prijmeni;
	}

	/**
	 * @return PracovniPozice
	 */
	public function getPracovniPozice()
	{
		return $this->pracovniPozice;
	}

	/**
	 * @param mixed $pracovniPozice
	 */
	public function setPracovniPozice(PracovniPozice $pracovniPozice)
	{
		$this->pracovniPozice = $pracovniPozice;
	}

	/**
	 * @return Proces
	 */
	public function getPridruzeneProcesy()
	{
		return $this->pridruzeneProcesy;
	}

	/**
	 * @return DateTime
	 */
	public function getDatumNastupu()
	{
		return $this->datumNastupu;
	}

	/**
	 * @param DateTime $datumNastupu
	 */
	public function setDatumNastupu($datumNastupu)
	{
		$this->datumNastupu = $datumNastupu;
	}


	public function addPridruzenyProces(Proces $pridruzenyProces) {
		if(!$this->pridruzeneProcesy->contains($pridruzenyProces)) {
			$this->pridruzeneProcesy->add($pridruzenyProces);
		}
	}




}