<?php

namespace App\Entity;


use Doctrine\ORM\Mapping as ORM;

/**
 * Class Produkt
 * @package App\Entity
 * @ORM\Entity()
 * @ORM\Table()
 */
class Produkt
{

	/**
	 * @var integer
	 * @ORM\Column(type="integer")
	 * @ORM\Id()
	 * @ORM\GeneratedValue()
	 */
	protected $id;

	/**
	 * @var string
	 * @ORM\Column(type="string")
	 */
	protected $nazev;

	/**
	 * @var string
	 * @ORM\Column(type="text", nullable=true)
	 */
	protected $popis;

	/**
	 * @var string
	 * @ORM\Column(type="string", options={"default": 0})
	 */
	protected $cena;

	/**
	 * @var Pracoviste
	 * @ORM\ManyToOne(targetEntity="Pracoviste", inversedBy="skladoveProdukty")
	 */
	protected $umisteni;


	/**
	 * @var Proces
	 * @ORM\OneToOne(targetEntity="Proces", inversedBy="prirazeneProdukty")
	 */
	protected $prirazenoProcesum;

	/**
	 * @return int
	 */
	public function getId()
	{
		return $this->id;
	}

	/**
	 * @return string
	 */
	public function getNazev()
	{
		return $this->nazev;
	}

	/**
	 * @param string $nazev
	 */
	public function setNazev($nazev)
	{
		$this->nazev = $nazev;
	}

	/**
	 * @return string
	 */
	public function getPopis()
	{
		return $this->popis;
	}

	/**
	 * @param string $popis
	 */
	public function setPopis($popis)
	{
		$this->popis = $popis;
	}

	/**
	 * @return string
	 */
	public function getCena()
	{
		return $this->cena;
	}

	/**
	 * @param string $cena
	 */
	public function setCena($cena)
	{
		$this->cena = $cena;
	}

	/**
	 * @return Pracoviste
	 */
	public function getUmisteni()
	{
		return $this->umisteni;
	}

	/**
	 * @param Pracoviste $umisteni
	 */
	public function setUmisteni($umisteni)
	{
		$this->umisteni = $umisteni;
	}

	/**
	 * @return Proces
	 */
	public function getPrirazenoProcesum()
	{
		return $this->prirazenoProcesum;
	}

}