<?php

namespace App\Grid;


use App\Entity\Pracoviste;
use Doctrine\ORM\EntityManager;

class PracovisteGrid
{

	/** @var  GridFactory */
	protected $gridFactory;

	protected $repository;

	public function __construct(GridFactory $gridFactory, EntityManager $em)
	{
		$this->gridFactory = $gridFactory;
		$this->repository = $em->getRepository(Pracoviste::class);
	}

	public function create() {
		$grid = $this->gridFactory->create();

		$grid->setDefaultPerPage(50);

		$grid->setDataSource($this->repository->createQueryBuilder('p'));

		$grid->addColumnText('id', 'ID')
			->setSortable();

		$grid->addColumnText('nazev', 'Název')
			->setSortable()
			->setFilterText();

		$grid->addColumnText('manazer', 'Manažer')
			->setRenderer(function(Pracoviste $item) {
				return $item->getManazer()->getPrijmeni()." ".$item->getManazer()->getJmeno();
			})
			->setSortable();

		$grid->addColumnText('pocetProcesu', 'Počet procesů');




		return $grid;
	}

}