<?php

namespace App\Presenters;


use App\Entity\Pracoviste;
use App\Forms\PracovisteForm;
use App\Grid\PracovisteGrid;
use Doctrine\ORM\Mapping\Entity;

class PracovistePresenter extends CrudPresenter
{

	/** @var  PracovisteGrid @inject */
	public $grid;

	/** @var  PracovisteForm @inject */
	public $form;

	public function renderAdd() {
		$this->template->title = "Přidat pracoviště";
	}

	public function renderEdit($id) {
		$this->template->title = "Upravit pracoviště";

		/** @var Pracoviste $entity */
		$entity = $this->getEntity($id);

		$pp = [];
		$pracovniPozice = $entity->getPracovniPozicePracoviste();
		foreach($pracovniPozice as $p) {
			$pp[] = $p->getId();
		}

		$this['editForm']->setDefaults([
			'id' => $entity->getId(),
			'manazer' => $entity->getManazer()->getId(),
			'pracovniPozicePracoviste' => $pp
		]);
	}

	private function getEntity($id) {
		return $this->em->getRepository(Pracoviste::class)->find($id);
	}

	public function actionDelete($id) {
		$entity = $this->getEntity($id);
		try {
			$this->em->remove($entity);
			$this->em->flush();
			$this->flashMessage('Objekt byl smazán');
			$this->redirect('default');

		}catch (DBALException $ex) {
			$this->flashMessage('Mazání se nepodařilo');
			$this->redirect('default');
		}
	}
}