<?php

namespace App\Presenters;


use App\Entity\Pracovnik;
use App\Forms\PracovnikForm;
use App\Grid\PracovnikGrid;

class PracovnikPresenter extends CrudPresenter
{

	/** @var  PracovnikForm @inject */
	public $form;

	/** @var PracovnikGrid @inject */
	public $grid;

	public function renderAdd() {
		$this->template->title = "Přidat pracovníka";
	}

	public function renderEdit($id) {
		$this->template->title = "Upravit pracovníka";

		/** @var Pracovnik $entity */
		$entity = $this->getEntity($id);
		$this['editForm']->setDefaults([
			'id' => $entity->getId(),
			'jmeno' => $entity->getJmeno(),
			'prijmeni' => $entity->getPrijmeni(),
			'pracovniPozice' => $entity->getPracovniPozice()->getId(),
			'datumNastupu' => $entity->getDatumNastupu()->format('j.n.Y')
		]);
	}

	private function getEntity($id) {
		return $this->em->getRepository(Pracovnik::class)->find($id);
	}

	public function renderDetail($id) {
		$this->template->pracovnik = $this->getEntity($id);

	}

	public function actionDelete($id) {
		$entity = $this->getEntity($id);
		try {
			$this->em->remove($entity);
			$this->em->flush();
			$this->flashMessage('Objekt byl smazán');
			$this->redirect('default');

		}catch (DBALException $ex) {
			$this->flashMessage('Mazání se nepodařilo');
			$this->redirect('default');
		}
	}

}