<?php

namespace App\Presenters;


use App\Entity\Produkt;
use App\Forms\ProduktForm;
use App\Grid\ProduktGrid;

class ProduktPresenter extends CrudPresenter
{
	/** @var  ProduktGrid @inject */
	public $grid;

	/** @var  ProduktForm @inject */
	public $form;

	public function renderDefault() {
		$this->template->title = "Přidat produkt";
	}

	public function renderEdit($id) {
		$this->template->title = "Upravit produkt";

		/** @var Produkt $entity */
		$entity = $this->getEntity($id);
		$this['editForm']->setDefaults([
				'id' => $entity->getId(),
			'nazev'	=> $entity->getNazev(),
			'cena' => $entity->getCena(),
			'umisteni' => $entity->getUmisteni() ?  $entity->getUmisteni()->getNazev() : NULL,
		]);
	}

	private function getEntity($id) {
		return $this->em->getRepository(Produkt::class)->find($id);
	}

	public function actionDelete($id) {
		$entity = $this->getEntity($id);
		try {
			$this->em->remove($entity);
			$this->em->flush();
			$this->flashMessage('Objekt byl smazán');
			$this->redirect('default');

		}catch (DBALException $ex) {
			$this->flashMessage('Mazání se nepodařilo');
			$this->redirect('default');
		}
	}
}