<?php

namespace App\Presenters;


use App\Entity\User;
use App\Forms\SignUpFormFactory;
use App\Grid\UserGrid;

class UserPresenter extends CrudPresenter
{

	/** @var  UserGrid @inject */
	public $grid;

	/** @var  SignUpFormFactory  @inject */
	public $form;

	public function renderEdit($id) {
		$user = $this->getEntity($id);
		$this['editForm']->setDefaults([
			'id' => $user->getId(),
			'name' => $user->getName(),
			'email' => $user->getEmail()
		]);
	}

	/**
	 * @param $id
	 * @return null|User
	 */
	private function getEntity($id) {
		return $this->em->getRepository(User::class)->find($id);
	}

	public function actionDelete($id) {
		$entity = $this->getEntity($id);
		try {
			$this->em->remove($entity);
			$this->em->flush();
			$this->flashMessage('Objekt byl smazán');
			$this->redirect('default');

		}catch (DBALException $ex) {
			$this->flashMessage('Mazání se nepodařilo');
			$this->redirect('default');
		}
	}

}